from nltk.translate.phrase_based import phrase_extraction
from yake import KeywordExtractor
from nltk.stem import WordNetLemmatizer
from nltk.stem import PorterStemmer
from nltk.tokenize import word_tokenize
  
ps = PorterStemmer()

# Create WordNetLemmatizer object
wnl = WordNetLemmatizer()

"""
get keywords using YAKE!

Arguments:
    array_text: list of articles
    lan: datasets language
    n_gram: n gram range
    kw_count: list of keywords count of each article

Returns:
    kw: list of keywords
"""

def get_keywords(array_text, lan, n_gram, kw_count):
    kw = []
    
    for j in range(len(array_text)):
        kw_extractor = KeywordExtractor(lan="cs", n=n_gram, top=len(kw_count[j]))
        keywords = kw_extractor.extract_keywords(text=array_text[j])
        keywords = [x for x, y in keywords]
        keywords = [x.lower() for x in keywords]
        lemma = []
        for phrase in keywords:
            if(" " in phrase):
                splitted_phrase = phrase.split(" ")
                lemmatized_output = ' '.join([wnl.lemmatize(w) for w in splitted_phrase])
                lemma.append(lemmatized_output)
            else:
                lemmatized_output = wnl.lemmatize(phrase)
                lemma.append(lemmatized_output)
        kw.append(lemma)
        #print(j)


    return kw